program setup32;

uses
  Forms,
  Windows,
  SysUtils,
  Classes,
  Dialogs,
  loadFrm in 'loadFrm.pas' {frm_Loader},
  setTool in 'setTool.pas',
  zlib in 'Zlib.pas',
  ZArcTyp in 'ZArcTyp.pas',
  loadData in 'loadData.pas' {Daten: TDataModule};

{$R *.RES}

var
   dcmpParam : TDecompParameter;
   Log : TStringList;
   Idx : Integer;
   sTmp : String;

begin
     Application.Title := 'Bitte warten...';
     Application.CreateForm(TDaten, Daten);

     // Logliste erzeugen
     Log := TStringList.Create;

     // Verzeichnisse und Setup Programm festlegen
     tmpDir := GetEnvStr('TEMP');
     if Copy(tmpDir, Length(tmpDir), 1) <> '\' then
        exeDir := tmpDir + '\setup.exe'
     else
         exeDir := tmpDir + 'setup.exe';
     srcDir := ExtractFileDir(Application.ExeName);

     // Form anzeigen
     frm_Loader := tfrm_Loader.Create(Application);
     frm_Loader.Show;
     frm_Loader.Repaint;

     // Dekomprimierer initialisieren
     with dcmpParam do
     begin
          if Copy(tmpDir, Length(tmpDir), 1) <> '\' then
             strTmpDir := tmpDir + '\'
          else
              strTmpDir := tmpDir;
          strArchivName := 'install.z';
          if Copy(srcDir, Length(srcDir), 1) <> '\' then
             strSourcePath := srcDir + '\'
          else
              strSourcePath := srcDir;
          if Copy(tmpDir, Length(tmpDir), 1) <> '\' then
             strDestPath := tmpDir + '\'
          else
              strDestPath := tmpDir;
          objMsgFile := frm_Loader.lbFile;
          objProgress := frm_Loader.ProgressBar;
          objStatus := frm_Loader.Status;
          objLog := Log;
          optRename := True;
     end;

     // Installationsdateien entpacken
     CopyAndDecompressZArchiv(dcmpParam);

     // Form schlieen
     frm_Loader.Release;

     // Setup durchfhren
     Daten.ExecFile.CommandLine := exeDir;
     Daten.ExecFile.Parameters := srcDir;
     Daten.ExecFile.Execute;

     // Setup Dateien wieder lschen
     for Idx := 1 to Log.Count do
     begin
          sTmp := Log[Idx - 1];
          Daten.BrkApart.BaseString := sTmp;
          Daten.BrkApart.BreakApart;
          sTmp := Daten.BrkApart.StringList[1];
          try
             DeleteFile(sTmp);
          except
          end;
     end;

     Log.Free;
end.
